            	LIST      P=16F84, F=INHX8M
            	include "P16F84.inc"
		__config _HS_OSC & _CP_OFF & _PWRTE_ON & _WDT_OFF    

XLO		equ	0x0C		
XHI		equ	0x0D	
X24		equ	0x0E
YLO		equ	0x0F		
YHI		equ	0x10
Y24		equ	0x11
ZLO		equ	0x12
ZHI		equ	0x13
Z24		equ	0x14
MessLO		equ	0x15		; enthaelt immer den Messwert
MessHI		equ	0x16
Mess24		equ	0x17
Zhl1		equ	0x1a
Zhl2		equ	0x1b
Zhl3		equ	0x1c
W_Temp		equ	0x1d
STATUS_Temp	equ	0x1e
temp		equ	0x1f		; temp eben:-)
TimerLO		equ	0x20		; Verlaengert den Timer
TimerHI		equ     0x21		; Verlaengert den Timer	
Impuls 		equ	0x22		; Enthaelt die Impulsanzahl/Umdrehung
Impuls_Temp	equ	0x23
Taster		equ	0x24		; Enthaelt die Tasterposition 
PORT		equ	0x25
;************************************************************************************************

Reset       	ORG     0x0000		;Resetvektor

	    	GOTO	Start

;************************************************************************************************
;Interuptroutinen
;************************************************************************************************

Interrupt	ORG	0x0004
		
		bcf	INTCON,GIE
		movwf	W_Temp		;W sichern!
		swapf	STATUS,w	
		movwf	STATUS_Temp	;Status sichern!
		btfsc	INTCON,T0IF	;Test ob Timer oder ext
		goto	Timerint	;Wenn Timer -->
		bcf	INTCON,RBIF	;Wenn loesche Interupt
		btfsc	PORTB,5		;L-Pegel
		goto	Intaus		;Nein --> 
		goto	EXTint		;ja
		
Timerint:	bcf	INTCON,T0IF	;Flag loeschen
		INCF	TimerLO,f
		BTFSC	STATUS,Z
		INCF	TimerHI,f		
		BTFSS	STATUS,Z
		goto    Intaus
Messstopp:	BSF	STATUS,RP0
		BSF	OPTION_REG,T0CS	;EXT = keine Messung
		BCF	STATUS,RP0
		MOVLW	0xff
		MOVWF	MessLO
		MOVWF	MessHI
		MOVWF	Mess24		;Periode = Max = Anzeigewert 0
		movf	Impuls,w
		movwf	Impuls_Temp
		decf	Impuls_Temp
		goto	Intaus

EXTint:		bsf	STATUS,RP0	;Bank1
		btfsc	OPTION_REG,T0CS
		goto 	Startmess
		incf	Impuls_Temp
		movf	Impuls,w	
		subwf	Impuls_Temp,w
		btfss	STATUS,Z
		goto	Intaus
		bsf	OPTION_REG,T0CS	;aus, interner Takt
		bcf	STATUS,RP0	;Bank0
		movf	TMR0,w
		movwf	MessLO
		btfss	INTCON,T0IF
		goto	lasses
		incf	TimerLO
		btfsc	STATUS,Z
		incf	TimerHI
		btfsc	STATUS,Z
		goto	Messstopp
		
lasses:		movf	TimerLO,w
		movwf	MessHI
		movf	TimerHI,w
		movwf	Mess24
		               
Startmess:	clrf	Impuls_Temp
		clrf	TimerLO
		clrf	TimerHI
		bsf	STATUS,RP0	;Bank1
		bcf	OPTION_REG,T0CS	;An, interner Takt
		bcf	STATUS,RP0	;Bank0
		clrf	TMR0
		incf	TMR0
Intaus:		swapf 	STATUS_Temp,w	;Status zuruecksichern
		movwf	STATUS 		
		swapf	W_Temp,f
		swapf	W_Temp,w
		bsf	INTCON,GIE	;Interupts freigeben
		RETFIE

;************************************************************************************************
;Initialisierung
;************************************************************************************************
 
Start:		BSF	STATUS,RP0	;Bank1 
		BsF	OPTION_REG,PSA	;Teiler fuer Wachhund
		BsF	OPTION_REG,T0CS	;!!! keine Messung
		BCF	STATUS,RP0	;Bank0
		BSF     STATUS    , RP0
            	MOVLW   0x20
            	MOVWF   TRISB
            	MOVLW   0x10
            	MOVWF   TRISA
            	BSF     OPTION_REG, NOT_RBPU
            	BCF     STATUS    , RP0
            	CLRF    PORTA
            	CLRF    PORTB
            	CALL    LCD_INI				
		clrf	TMR0
		clrf	TimerLO
		clrf	TimerHI
	      	MOVLW	0xff
		MOVWF	MessLO
		MOVWF	MessHI	
		Movwf	Mess24		;Periode = Max = Anzeigewert 0

;************************************************************************************************
; Einstellen der Impulsanzal
;************************************************************************************************

Impulseinstell:	call	Warten50ms	; sonst gehts zu schnell
 
;************************************************************************************************
; Anzeige der Impulsanzal
;************************************************************************************************

		movlw	0x80		; 1. Zeile im Display
		call	LCD_CMD
		movlw	" "
		call	LCD_ZEICHEN

		movlw	0x00		;Adresse 0 fuer EE
		call 	EE_READ		;jetzt Impulsanzahl in w
		movwf	XLO		;Impulsanzahl nach X24:XHI:ZLO
		clrf	XHI	
		clrf	X24
		call	Dezimalanzeige
		movlw	" "
		call	LCD_ZEICHEN

		movlw	0xc0		; Zeile 2 vom LCD
		call	LCD_CMD
		movlw	"I"
		call	LCD_ZEICHEN
		movlw	"m"
		call	LCD_ZEICHEN
		movlw	"p"
		call	LCD_ZEICHEN
		movlw	"u"
		call	LCD_ZEICHEN
		movlw	"l"
		call	LCD_ZEICHEN
		movlw	"s"
		call	LCD_ZEICHEN
		movlw	"e"			; muessen "wir" noch bei 1 ausblenden
		call	LCD_ZEICHEN

;**************************************************************************
; Tasterabfrage
;**************************************************************************

		Call 	Tastertest
		movf	Taster,w		;Taster nach w
		andlw	0x11			;nur bit 1 und bit 4
		sublw	0x11			;gesetzt?
		btfsc	STATUS,Z
		goto	PLUSeins		;dann -->
		movf	Taster,w		;Taster nach w
		andlw	0x01			;Nur Aenderung
		sublw	0x01			;gesetzt?
		btfsc	STATUS,Z		;nein -->
		goto	Impulseinstell
		incf	TimerLO			;Wartezeit bis Abbruch
		movf	TimerLO,w
		sublw	.255
		btfss	STATUS,Z
		goto	Impulseinstell
		btfss	Taster,4
		goto 	Anfang
		movlw	0x01
		clrf	TimerLO
		clrf	temp
		call	EE_WRITE
		goto	Impulseinstell

;**************************************************************************
; Impulsanzahl erhoehen
;**************************************************************************
	
PLUSeins:	clrf	TimerLO		; Rucksetzen Wartezeit fuer Abbruch
		movlw	0x00
		call 	EE_READ
		addLW	1
		andLW	B'01111111'
		btfsc	STATUS,Z
		addlw	1
		clrf	temp
		call	EE_WRITE
		goto	Impulseinstell

;************************************************************************************************
; Freigabe der Interupts
;************************************************************************************************

Anfang:		movlw	0x00
		call 	EE_READ
		movwf	Impuls		; Laden der Impulsanzahl
		rlf	Impuls,f	; x2
		bcf	Impuls,0	; (warum weiss ich nicht:-(	
		movf	Impuls,w	;
		movwf	Impuls_Temp
		decf	Impuls_Temp
		bsf	INTCON,RBIE	; Externen interupt freigeben
		bsf	INTCON,T0IE	; Timerinterupt freigeben		
		bcf	INTCON,T0IF
		bcf	INTCON,RBIF

;********************************************************************************
; Holen der Messwerte
;********************************************************************************
		
Hole:		BCF	INTCON,GIE	; Interupt sperren
		MOVF	MessLO,w
		MOVWF	YLO
		movf	MessHI,w
		movwf	YHI
		movf	Mess24,w
		movwf	Y24
		
		BsF	INTCON,GIE	; Interupt wieder freigeben

;********************************************************************************
; Berechnen der temp 
;********************************************************************************
		
		movlw	0xE4
		MOVWF	X24
		movlw	0xE1
		MOVWF	XHI
		MOVLW	0xc0
		MOVWF	XLO		; jetzt Konstante 12288000 in XHI:XLO
		
		call	Subtra		; jetzt steht die Drehzahl in ZHI:ZLO

;********************************************************************************
; Anzeige  
;********************************************************************************

Anzeige		movf	ZLO,w		
		movwf	XLO
		movf	ZHI,w
		movwf	XHI
		movf	Z24,w		
		movwf	X24
		
		movlw	0x80
		call	LCD_CMD
		movlw	" "
		call	LCD_ZEICHEN
		
		call	Dezimalanzeige
		
		movlw	"0"
		call	LCD_ZEICHEN
		movlw	0xc0		;Zeile 2
		call	LCD_CMD
		movlw	" "
		call	LCD_ZEICHEN
		movlw	"U"
		call	LCD_ZEICHEN
		movlw	"/"
		call	LCD_ZEICHEN
		movlw	"m"
		call	LCD_ZEICHEN
		movlw	"i"
		call	LCD_ZEICHEN
		movlw	"n"
		call	LCD_ZEICHEN
		movlw	" "
		call	LCD_ZEICHEN

		call	Warten1sec
		goto 	Hole

;************************************************************************************************
;24bit Subtraktion	X24:XHI:XLO/Y24:YHI:YLO=Z24:ZHI:ZLO
;W und Status werden veraendert
;************************************************************************************************

Subtra:		movlw	0xff
		movwf	ZLO
		movwf	ZHI
		movwf	Z24
Subtra1:	incf	ZLO		;Zaehler+1 
		btfsc	STATUS,Z
		incf	ZHI
		btfsc	STATUS,Z
		incf	Z24
		movf	YLO,w		; sub LO
		subwf	XLO,f
		movlw	1
		btfss	STATUS,C
		subwf	XHI,f
		btfss	STATUS,C
		subwf	X24,f
		btfss	STATUS,C
		goto	Subtra3
		movf	YHI,w
		subwf	XHI,f
		movlw	1
		btfss	STATUS,C
		subwf	X24,f
		btfss	STATUS,C
		goto	Subtra2
		movf	Y24,w
		subwf	X24,f
		btfsc	STATUS,C
		goto	Subtra1
		addwf	X24,f
Subtra2:	movf	YHI,w
		addwf	XHI
		btfsc	STATUS,C
		incf	X24
Subtra3:	movf	YLO,w
		addwf	XLO	
		btfsc	STATUS,C
		incf	XHI
		btfsc	STATUS,Z
		incf	X24
		Return

;****************************************************************************
; Routinen fuer das LCD Modul
;****************************************************************************

LCD_ZEICHEN MOVWF   temp
            CALL    Warten25ns
            MOVLW   0xF0
            ANDWF   PORTB     , f
            SWAPF   temp      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BCF     PORTA     , 02
            BSF     PORTA     , 01
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            MOVLW   0xF0
            ANDWF   PORTB     , f
            MOVF    temp      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            RETURN

LCD_CMD	    MOVWF   temp
            CALL    Warten25ns
            BSF     STATUS    , RP0
            MOVLW   0xF0
            andwf   TRISB     , W
            MOVWF   TRISB
            BCF     STATUS    , RP0
            MOVLW   0xF0
            ANDWF   PORTB     , f
            SWAPF   temp      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BCF     PORTA     , 02
            BCF     PORTA     , 01
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            MOVLW   0xF0
            ANDWF   PORTB     , f
            MOVF    temp      , W
            ANDLW   0x0F
            IORWF   PORTB     , f
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            RETURN

;Initialisieren des LCD-Modules

LCD_INI     CALL    Warten5ms
            BCF     PORTA     , 03
            BCF     PORTA     , 01
            BCF     PORTA     , 02
            CALL    Warten5ms
            MOVLW   0x03
            MOVWF   PORTB
            BSF     STATUS    , RP0
            MOVLW   0xF0
            ANDWF   TRISB     , W
            MOVWF   TRISB
            BCF     STATUS    , RP0
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            CALL    Warten5ms
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            CALL    Warten5ms
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            CALL    Warten25ns
            MOVLW   0x02
            MOVWF   PORTB
            BSF     PORTA     , 03
            BCF     PORTA     , 03
            MOVLW   0x28
            CALL    LCD_CMD
            MOVLW   0x08
            CALL    LCD_CMD
            MOVLW   0x0C
            CALL    LCD_CMD
            MOVLW   0x06
            CALL    LCD_CMD
            RETURN

Warten25ns: MOVLW   0x16
            MOVWF   Zhl1
            MOVLW   0x02
            MOVWF   Zhl2
            MOVLW   0x01
            MOVWF   Zhl3
            GOTO    Loop

Warten5ms:  MOVLW   0x9C
            MOVWF   Zhl1
            MOVLW   0x15
            MOVWF   Zhl2
            MOVLW   0x01
            MOVWF   Zhl3
	    GOTO    Loop	

Warten50ms: MOVLW   0x1
            MOVWF   Zhl1
            MOVLW   0x01
            MOVWF   Zhl2
            MOVLW   0x01
            MOVWF   Zhl3
	    GOTO    Loop	
	
Warten1sec: MOVLW   0x00
            MOVWF   Zhl1
            MOVLW   0x80
            MOVWF   Zhl2
            MOVLW   0x9
            MOVWF   Zhl3

Loop        NOP
	    DECFSZ  Zhl1      , f
            GOTO    Loop
            DECFSZ  Zhl2     , f
            GOTO    Loop
            DECFSZ  Zhl3      , f
            GOTO    Loop
            RETURN

LCD_RET     MOVLW   0x01
            CALL    LCD_CMD
            CALL    Warten50ms
            RETURN

;************************************************************************************************
; Lesen des EE_PROM
; EE-Adresse in w uebergeben
; Rueckgabe des Speicherinhaltes in w
;************************************************************************************************

EE_READ:	movwf	EEADR			;EEPROM Adresse setzen
		BSF	STATUS,RP0		;Registerbank1
		BSF	EECON1,RD		;EEPROM Lesestart
		BCF	STATUS,RP0		;Registerbank0
		CALL    Warten5ms
		movf	EEDATA,w		
		return

;************************************************************************************************
; Schreiben des EE_PROM
; EE-Adresse in Temp uebergeben Wert in w
;************************************************************************************************
		
EE_WRITE:	movwf	EEDATA
		movf	temp,w
		movwf	EEADR
		BSF	STATUS,RP0		;Registerbank1
		BSF	EECON1,WREN		;Schreiben bereit
		MOVLW	0x55
		MOVWF	EECON2
		MOVLW	0xAA
		MOVWF	EECON2
		BSF	EECON1,WR
EEfertig	BSF	STATUS,RP0		;Registerbank1
		BTFSS	EECON1,EEIF
		GOTO	EEfertig
          	BCF	EECON1,EEIF
		BCF	EECON1,WREN
		BCF	STATUS,RP0		;Registerbank0
		RETURN

;**************************************************************************
; Tastertest
; ERgebnis in Taster
;**************************************************************************

Tastertest:	swapf	Taster,f	;Letzter Tasterwert in unteres Nibble
		movlw	0x0f		
		andwf	Taster,f	;TasterVariable oberes Nibble loeschen
		bsf	STATUS,RP0	;Bank 1
		bsf	TRISB,4		;Taster auf Eingang 
		bcf	STATUS,RP0	;Bank 0
		movf	PORTB,w
		xORLW	0xf0		;bitts umkehren
		andlw	0x10		;nur bit 4
		iorwf	Taster		; jetzt Taster in oberem Nibble
	    	swapf	Taster,w
		andlw	0x01		;nur bit1
		xorwf	Taster,f
		return

;**************************************************************************
; Dezimale ausgabe von X24:XHI:XLO
;**************************************************************************

Dezimalanzeige:	movlw	0x01
		Movwf	Y24
		movlw	0x86
		movwf	YHI
		movlw	0xa0
		movwf	YLO		;jetzt 100000 in Y
		call 	Subtra
		movf	ZLO,w
		btfss	STATUS,Z
		goto	Anz1
		addlw	-0x10
Anz1:		addlw	0x30
		call	LCD_ZEICHEN
		
		movlw	0x00
		Movwf	Y24
		movlw	0x27
		movwf	YHI
		movlw	0x10
		movwf	YLO		;jetzt 10000 in Y
		call 	Subtra
		movf	ZLO,w
		btfss	STATUS,Z
		goto	Anz2
		movlw	" "
		subwf	temp,f
		movlw	0
		btfsc	STATUS,Z
		addlw	-0x10
Anz2:		addlw	0x30
		call	LCD_ZEICHEN
		
		movlw	0x00
		Movwf	Y24
		movlw	0x03
		movwf	YHI
		movlw	0xe8
		movwf	YLO		;jetzt 1000 in Y
		call 	Subtra
		movf	ZLO,w
		btfss	STATUS,Z
		goto	Anz3
		movlw	" "
		subwf	temp,f
		movlw	0
		btfsc	STATUS,Z
		addlw	-0x10
Anz3:		addlw	0x30
		call	LCD_ZEICHEN

		movlw	0x00
		Movwf	Y24
		movlw	0x00
		movwf	YHI
		movlw	0x64
		movwf	YLO		;jetzt 100 in Y
		call 	Subtra
		movf	ZLO,w
		btfss	STATUS,Z
		goto	Anz4
		movlw	" "
		subwf	temp,f
		movlw	0
		btfsc	STATUS,Z
		addlw	-0x10
Anz4:		addlw	0x30
		call	LCD_ZEICHEN

		movlw	0x00
		Movwf	Y24
		movlw	0x00
		movwf	YHI
		movlw	0x0a
		movwf	YLO		;jetzt 10 in Y
		call 	Subtra
		movf	ZLO,w
		btfss	STATUS,Z
		goto	Anz5
		movlw	" "
		subwf	temp,f
		movlw	0
		btfsc	STATUS,Z
		addlw	-0x10
Anz5:		addlw	0x30
		call	LCD_ZEICHEN

		movf	XLO,w
		btfss	STATUS,Z
		goto	Anz6
		movlw	" "
		subwf	temp,f
		movlw	0
		btfsc	STATUS,Z
		addlw	-0x10
Anz6:		addlw	0x30
		goto	LCD_ZEICHEN

		end

